<?php
/**
 * This file is part of a NewQuest Project
 *
 * (c) NewQuest <contact@newquest.fr>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author    NewQuest
 * @copyright NewQuest
 * @license   NewQuest
 */

class NQLogger
{
    const TYPE_ERROR = 1;
    const TYPE_INFO = 2;
    const TYPE_NOTICE = 3;

    public static $table = 'ozon_log';

    /**
     * Create NQLogger table.
     * @return mixed
     */
    public static function createTable()
    {
        $query = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.self::$table.'` (
		  `id_log` int(11) NOT NULL AUTO_INCREMENT,
		  `message` varchar(255) DEFAULT NULL,
		  `id_entity` int(11) DEFAULT NULL,
		  `type` tinyint(1) DEFAULT NULL,
		  `date_add` datetime DEFAULT NULL,
		  PRIMARY KEY (`id_log`)
		) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';
        return Db::getInstance()->execute($query);
    }

    /**
     * Drop NQLogger table.
     * @return mixed
     */
    public static function dropTable()
    {
        $query = 'DROP TABLE IF EXISTS `'._DB_PREFIX_.self::$table.'`';
        return Db::getInstance()->execute($query);
    }

    /**
     * Add new log line.
     * @param $message
     * @param $id_entity
     * @param int $type
     */
    public static function addLog($message, $id_entity, $type = self::TYPE_ERROR)
    {
        $query = 'INSERT INTO '._DB_PREFIX_.self::$table.' (`id_log`, `message`, `id_entity`, `type`, `date_add`)
		VALUES ("", "'.pSQL($message).'", '.(int)$id_entity.', '.(int)$type.', "'.date('Y-m-d H:i:s').'")';
        Db::getInstance()->Execute($query);
    }

    /**
     * Get logs lines.
     * @param null $type
     * @return mixed
     */
    public static function getLogs($type = null)
    {
        $where_type = '';
        if ($type !== null) {
            $where_type = ' WHERE type = '.(int)$type;
        }

        $query = 'SELECT * FROM '._DB_PREFIX_.self::$table.' '.$where_type.' ORDER BY date_add DESC';
        return Db::getInstance()->ExecuteS($query);
    }
}
