<?php
/**
 * This file is part of a NewQuest Project
 *
 * (c) NewQuest <contact@newquest.fr>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author    NewQuest
 * @copyright NewQuest
 * @license   NewQuest
 */

$sql = array();

/*
 * Order index table.
 */
$sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'ozon_order_index` (
  `id_order` int(11) NOT NULL,
  `success` tinyint(1) NOT NULL DEFAULT "0",
  `ozon_order_id` varchar(128) DEFAULT NULL,
  `score` int(4) DEFAULT NULL,
  `order_risk` varchar(32) DEFAULT NULL,
  `proxy_score` decimal(6,2) DEFAULT NULL,
  `ip_user_type` varchar(128) DEFAULT NULL,
  `high_risk_email` tinyint(1) NOT NULL DEFAULT "0",
  `proxy_anonymous` tinyint(1) NOT NULL DEFAULT "0",
  `message` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `tags` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `date_add` datetime DEFAULT NULL,
  PRIMARY KEY (`id_order`)
) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';


/*
 * Order tag table.
 */
$sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'ozon_order_tag` (
  `id_ozon_tag` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `date_add` datetime DEFAULT NULL,
  PRIMARY KEY (`id_ozon_tag`)
) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

/*
 * Uuid index table.
 */
$sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'ozon_uuid_index` (
  `id_cart` int(11) NOT NULL,
  `uuid` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id_cart`)
) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

foreach ($sql as $query) {
    if (!Db::getInstance()->execute($query)) {
        return false;
    }
}
