{*
* This file is part of a NewQuest Project
*
* (c) NewQuest <contact@newquest.fr>
*
* For the full copyright and license information, please view the LICENSE
* file that was distributed with this source code.
*
* @author    NewQuest
* @copyright NewQuest
* @license   NewQuest
*}

<div class="row">
    <div class="col-lg-12">
        <div id="orderOzon" class="panel">
            <div class="panel-heading">
                {l s='Analyse de commande par Ozon' mod='ozon'}
            </div>
            <div>
                {if $order_data}
                {if $order_data.success}
                <h4 style="font-size: 150%;">
                    {l s='Score : ' mod='ozon'}
                    <strong>
                        <span class="label color_field"
                              style="background-color:{$order_data.color_risk|escape:'htmlall':'UTF-8'};color:white; font-size: 20px;">
                            {$order_data.score|escape:'htmlall':'UTF-8'} / 100
                        </span>
                    </strong>
                </h4>
                <br/>

                <ul>
                    <li>
                        <strong>{l s='Id order Ozon : ' mod='ozon'}</strong>
                        <span class="label color_field"
                              style="background-color:#4169E1;color:white">{$order_data.ozon_order_id|escape:'htmlall':'UTF-8'}</span>
                    </li>
                    <li>
                        <strong>{l s='IP User Type : ' mod='ozon'}</strong>
                        <span class="label color_field"
                              style="background-color:#4169E1;color:white">{$order_data.ip_user_type|escape:'htmlall':'UTF-8'}</span>
                    </li>
                    <li>
                        <strong>{l s='High Risk Mail : ' mod='ozon'}</strong>
                        {if $order_data.high_risk_email}
                            <span class="label color_field"
                                  style="background-color:#FF8C00;color:black">{l s='Oui' mod='ozon'}</span>
                        {else}
                            <span class="label color_field"
                                  style="background-color:#4169E1;color:white">{l s='Non' mod='ozon'}</span>
                        {/if}
                    </li>
                    <li>
                        <strong>{l s='Proxy Annymous : ' mod='ozon'}</strong>
                        {if $order_data.proxy_anonymous}
                            <span class="label color_field"
                                  style="background-color:#FF8C00;color:black">{l s='Oui' mod='ozon'}</span>
                        {else}
                            <span class="label color_field"
                                  style="background-color:#4169E1;color:white">{l s='Non' mod='ozon'}</span>
                        {/if}
                    </li>
                    <li>
                        <strong>{l s='Proxy Score : ' mod='ozon'}</strong>
                        <span class="label color_field"
                              style="background-color:#4169E1;color:white">{$order_data.proxy_score|escape:'htmlall':'UTF-8'}</span>
                    </li>
                    <li>
                        {if isset($order_data.tags_list)}
                            <strong>{l s='Tags : ' mod='ozon'}</strong>
                            {foreach $order_data.tags_list as $tag}
                                <span class="label color_field"
                                      style="background-color:#4169E1;color:white">{$tag.name|escape:'htmlall':'UTF-8'}</span>
                            {/foreach}
                        {/if}
                    </li>

                    {if !$order_data.ozon_uuid}
                        <li>
                            <strong>{l s='Ozon_uuid : ' mod='ozon'}</strong>
                                <span class="label color_field"
                                      style="background-color:#FF8C00;color:black">{l s='Empty Ozon_uuid' mod='ozon'}</span>
                        </li>
                    {/if}
                </ul>

                    {if $order_data.ozon_uuid}
                        <br/>
                        <div>
                            <a href="https://manager.ozon.io/frauds/show_user/{$order_data.ozon_uuid|escape:'htmlall':'UTF-8'}" target="_blank"
                               class="btn btn-primary">{l s='Check this user' mod='ozon'}</a>
                        </div>
                    {/if}
                    {else}
                    <p>
                    {l s='Une erreur s\'est produite pendant le traitement de cette commande par Ozon : ' mod='ozon'}
                    {$order_data.message|escape:'htmlall':'UTF-8'}
                    </p>
                    {/if}
                    {else}
                    <p>{l s='Cette commande n\'a pas encore été traité par Ozon.' mod='ozon'}</p>
                    {/if}
            </div>
        </div>
    </div>
</div>