{*
*  This file is part of the 'Videos' module feature developped for Prestashop  platform.
* 
*  You are not allowed to use it on several site
*  You are not allowed to sell or redistribute this module
*  This header must not be removed
* 
*  @author    Botigues.cat <info@botigues.cat>
*  @copyright 2014 Botigues.cat
*  @version  1.5.1
*}

{extends file="helpers/form/form.tpl"}

{block name="input"}
	{if $input.name == "link_rewrite"}
		<script type="text/javascript">
		{if isset($PS_ALLOW_ACCENTED_CHARS_URL) && $PS_ALLOW_ACCENTED_CHARS_URL}
			var PS_ALLOW_ACCENTED_CHARS_URL = 1;
		{else}
			var PS_ALLOW_ACCENTED_CHARS_URL = 0;
		{/if}
		</script>
		{$smarty.block.parent}
	{else if $input.name == 'inputRelatedProducts'}
                <input type="hidden" name="inputRelatedProducts" id="inputRelatedProducts" value="{foreach from=$products item=product}{$product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}" />
                <input type="hidden" name="nameRelatedProducts" id="nameRelatedProducts" value="{foreach from=$products item=product}{$product.name|escape:'htmlall':'UTF-8'}¤{/foreach}" />

                <div id="ajax_choose_product">
                        <p>
                                <input type="text" value="" id="product_autocomplete_input" />
                                {l s='Begin typing the first letters of the product name, then select the product from the drop-down list' mod='videos'}
                        </p>
                        <p class="preference_description">{l s='(Do not forget to save the product afterward)' mod='videos'}</p>
                </div>
                <div id="divRelatedProducts">
                        {* @todo : donot use 3 foreach, but assign var *}
                        {foreach from=$products item=product}
                                {$product.id_product|escape:'htmlall':'UTF-8'} - {$product.name|escape:'htmlall':'UTF-8'}
                                <span class="delRelatedProduct" name="{$product.id_product|escape:'htmlall':'UTF-8'}" style="cursor: pointer;">
                                        <img src="../img/admin/delete.gif" class="middle" alt="" />
                                </span><br />
                        {/foreach}
                </div>
	{else if $input.name == 'categories'}
                <table cellspacing="0" cellpadding="0" class="table" style="min-width:500px;">
                        <tr>
                            <th style="width:40px;"><input type="checkbox" name="checkme" class="noborder" onclick="checkDelBoxes(this.form, 'categories[]', this.checked)" /></th>
                            <th style="width:30px;">{l s='ID' mod='videos'}</th>
                            <th>{l s='Category name' mod='videos'}</th>
                        </tr>
                        {foreach from=$categories item=cat}
                                <tr class="' . ($irow++ % 2 ? 'alt_row' : '') . '">
                                        <td><input type="checkbox" name="categories[]" class="categories" id="categories_{$cat.id_video_category|escape:'htmlall':'UTF-8'}" value="{$cat.id_video_category|escape:'htmlall':'UTF-8'}" {if in_array($cat.id_video_category, $post_categories)}checked="checked"{/if}/></td>
                                        <td>{$cat.id_video_category|escape:'htmlall':'UTF-8'}</td>
                                        <td><label for="categories_{$cat.id_video_category|escape:'htmlall':'UTF-8'}" class="t">{$cat.name|escape:'htmlall':'UTF-8'}</label></td>
                                </tr>
                        {/foreach}
                </table>
	{else}
		{$smarty.block.parent}
	{/if}
{/block}

{block name="script"}
        {literal}
        $(document).ready(function () {
                initRelatedProductsAutocomplete();
                
		$('#divRelatedProducts').delegate('.delRelatedProduct', 'click', function(){
			delRelatedProduct($(this).attr('name'));
		});
        });
	function initRelatedProductsAutocomplete(){
		$('#product_autocomplete_input')
			.autocomplete('ajax_products_list.php', {
				minChars: 1,
				autoFill: true,
				max:20,
				matchContains: true,
				mustMatch:true,
				scroll:false,
				cacheLength:0,
				formatItem: function(item) {
					return item[1]+' - '+item[0];
				}
			}).result(this.addRelatedProduct);

		$('#product_autocomplete_input').setOptions({
			extraParams: {
				excludeIds : this.getRelatedProductsIds
			}
		});
	};

	function getRelatedProductsIds()
	{
		if ($('#inputRelatedProducts').val() === undefined)
			return '';
		ids = $('#inputRelatedProducts').val().replace(/\\-/g,',').replace(/\\,$/,'');
		ids = ids.replace(/\,$/,'');

		return ids;
	}

	function addRelatedProduct(event, data, formatted)
	{
		if (data == null)
			return false;
		var productId = data[1];
		var productName = data[0];

		var $divRelatedProducts = $('#divRelatedProducts');
		var $inputRelatedProducts = $('#inputRelatedProducts');
		var $nameRelatedProducts = $('#nameRelatedProducts');

		/* delete product from select + add product line to the div, input_name, input_ids elements */
		$divRelatedProducts.html($divRelatedProducts.html() + productId + ' - ' + productName + ' <span class="delRelatedProduct" name="' + productId + '" style="cursor: pointer;"><img src="../img/admin/delete.gif" /></span><br />');
		$nameRelatedProducts.val($nameRelatedProducts.val() + productName + '¤');
		$inputRelatedProducts.val($inputRelatedProducts.val() + productId + '-');
		$('#product_autocomplete_input').val('');
		$('#product_autocomplete_input').setOptions({
			extraParams: {excludeIds : getRelatedProductsIds()}
		});
	};

	function delRelatedProduct(id)
	{
		var div = getE('divRelatedProducts');
		var input = getE('inputRelatedProducts');
		var name = getE('nameRelatedProducts');

		// Cut hidden fields in array
		var inputCut = input.value.split('-');
		var nameCut = name.value.split('¤');

		if (inputCut.length != nameCut.length)
			return jAlert('Bad size');

		// Reset all hidden fields
		input.value = '';
		name.value = '';
		div.innerHTML = '';
		for (i in inputCut)
		{
			// If empty, error, next
			if (!inputCut[i] || !nameCut[i])
				continue ;

			// Add to hidden fields no selected products OR add to select field selected product
			if (inputCut[i] != id)
			{
				input.value += inputCut[i] + '-';
				name.value += nameCut[i] + '¤';
				div.innerHTML += nameCut[i] + ' <span class="delRelatedProduct" name="' + inputCut[i] + '" style="cursor: pointer;"><img src="../img/admin/delete.gif" /></span><br />';
			}
			else
				$('#selectRelatedProducts').append('<option selected="selected" value="' + inputCut[i] + '-' + nameCut[i] + '">' + inputCut[i] + ' - ' + nameCut[i] + '</option>');
		}

		$('#product_autocomplete_input').setOptions({
			extraParams: {excludeIds : getRelatedProductsIds()}
		});
	};
        {/literal}
{/block}