{*
*  This file is part of the 'Videos' module feature developped for Prestashop  platform.
* 
*  You are not allowed to use it on several site
*  You are not allowed to sell or redistribute this module
*  This header must not be removed
* 
*  @author    Botigues.cat <info@botigues.cat>
*  @copyright 2014 Botigues.cat
*  @version  1.5.1
*}

{if !$path}
    {capture name=path}{l s='Videos' mod='videos'}{/capture}
{/if}

{include file="$tpl_dir./errors.tpl"}


{if isset($category)}
	{if isset($category->id) AND isset($category->active) AND !$category->active}
		<p class="warning">{l s='This category is currently unavailable.' mod='videos'}</p>
        {else}
                <div class="video_page">
                    <h1>{l s='Videos' mod='videos'}</h1>
                    {if isset($categories) && !empty($categories)}
                        <ul id="video_categories">
                            {foreach from=$categories item=category name=categories}
                                <li><a {if $id_category == $category.id_video_category}class="selected"{/if} href="{$category.link|escape:'htmlall':'UTF-8'}">{$category.name|escape:'htmlall':'UTF-8'}</a></li>
                            {/foreach}
                        </ul>
                    {/if}
                    
                    {if isset($videos) AND $videos}
                        <div id="videos_block">
                            {assign var=ppl value=2}
                            {assign var=index value=1}
                            <ul class="video-list">
                            {foreach from=$videos item=video name=video}
                                <li class="video {if $index % $ppl == 0 || $smarty.foreach.video.last} last_item_of_line{/if}" >
                                    <div class="img">
                                        <img src="{$base_dir}img/videos/{$video.image|escape:'htmlall':'UTF-8'}" alt="{$video.name|escape:'htmlall':'UTF-8'}" width="218" height="174" />
                                    </div>
                                    <div class="info">
                                        <h3>{$video.name|escape:'htmlall':'UTF-8'}</h3>
                                        {if isset($video.description_short)}<p>{$video.description_short|escape:'htmlall':'UTF-8'}</p>{/if}
                                        {if isset($video.link)}<a href="{$video.link|escape:'htmlall':'UTF-8'}">{l s='Watch video' mod='videos'}</a>{/if}
                                    </div>
                                </li>
                                {assign var=index value=$index+1}
                            {/foreach}
                            </ul>
                            <div class="clear"></div>
                        </div>
                    {/if}
                </div>
	{/if}
{/if}