{*
*  This file is part of the 'Videos' module feature developped for Prestashop  platform.
* 
*  You are not allowed to use it on several site
*  You are not allowed to sell or redistribute this module
*  This header must not be removed
* 
*  @author    Botigues.cat <info@botigues.cat>
*  @copyright 2014 Botigues.cat
*  @version  1.5.1
*}

{if !$path}
    {capture name=path}{l s='Videos' mod='videos'}{/capture}
{/if}

{include file="$tpl_dir./errors.tpl"}


{if isset($category)}
	{if isset($category->id) AND isset($category->active) AND !$category->active}
		<p class="warning">{l s='This category is currently unavailable.' mod='videos'}</p>
        {else}
                <div class="video_page">
                    <h1>{l s='Videos' mod='videos'}</h1>
                    {if isset($categories) && !empty($categories)}
                        <ul id="video_categories">
                            {foreach from=$categories item=category name=categories}
                                <li><a {if $id_category == $category.id_video_category}class="selected"{/if} href="{$category.link|escape:'htmlall':'UTF-8'}">{$category.name|escape:'htmlall':'UTF-8'}</a></li>
                            {/foreach}
                        </ul>
                    {/if}
                    
                    {if isset($videos) AND $videos}
                        <div id="videos_block">
                        {assign var='nbItemsPerLine' value=4}
                        {assign var='nbItemsPerLineTablet' value=3}
                        {assign var='nbItemsPerLineMobile' value=2}
                        {*define numbers of product per line in other page for tablet*}
                        {assign var='nbLi' value=$videos|@count}
                        {math equation="nbLi/nbItemsPerLine" nbLi=$nbLi nbItemsPerLine=$nbItemsPerLine assign=nbLines}
                        {math equation="nbLi/nbItemsPerLineTablet" nbLi=$nbLi nbItemsPerLineTablet=$nbItemsPerLineTablet assign=nbLinesTablet}
                            <ul class="video_list row list">
                            {foreach from=$videos item=video name=videos}
                                {math equation="(total%perLine)" total=$smarty.foreach.videos.total perLine=$nbItemsPerLine assign=totModulo}
                                {math equation="(total%perLineT)" total=$smarty.foreach.videos.total perLineT=$nbItemsPerLineTablet assign=totModuloTablet}
                                {math equation="(total%perLineT)" total=$smarty.foreach.videos.total perLineT=$nbItemsPerLineMobile assign=totModuloMobile}
                                {if $totModulo == 0}{assign var='totModulo' value=$nbItemsPerLine}{/if}
                                {if $totModuloTablet == 0}{assign var='totModuloTablet' value=$nbItemsPerLineTablet}{/if}
                                {if $totModuloMobile == 0}{assign var='totModuloMobile' value=$nbItemsPerLineMobile}{/if}
                                <li class="video col-xs-12{if $smarty.foreach.videos.iteration%$nbItemsPerLine == 0} last-in-line{elseif $smarty.foreach.videos.iteration%$nbItemsPerLine == 1} first-in-line{/if}{if $smarty.foreach.videos.iteration > ($smarty.foreach.videos.total - $totModulo)} last-line{/if}{if $smarty.foreach.videos.iteration%$nbItemsPerLineTablet == 0} last-item-of-tablet-line{elseif $smarty.foreach.videos.iteration%$nbItemsPerLineTablet == 1} first-item-of-tablet-line{/if}{if $smarty.foreach.videos.iteration%$nbItemsPerLineMobile == 0} last-item-of-mobile-line{elseif $smarty.foreach.videos.iteration%$nbItemsPerLineMobile == 1} first-item-of-mobile-line{/if}{if $smarty.foreach.videos.iteration > ($smarty.foreach.videos.total - $totModuloMobile)} last-mobile-line{/if}">
                                    <div class="video-container">
                                        <div class="row">
                                            <div class="left-block col-xs-12 col-sm-5 col-md-5">
                                                <img class="img-responsive" src="{$base_dir}img/videos/{$video.image|escape:'htmlall':'UTF-8'}" alt="{$video.name|escape:'htmlall':'UTF-8'}" />
                                            </div>
                                            <div class="center-block col-xs-12 col-sm-4 col-md-4">
                                                <h3>{$video.name|escape:'htmlall':'UTF-8'}</h3>
                                                {if isset($video.description_short)}<p>{$video.description_short|escape:'htmlall':'UTF-8'}</p>{/if}
                                            </div>
                                            <div class="right-block col-xs-12 col-sm-3 col-md-3">
                                                {if isset($video.link)}
                                                <a class="button lnk_view btn btn-default" href="{$video.link|escape:'htmlall':'UTF-8'}" title="{l s='Watch video' mod='videos'}">
                                                    <span>{l s='Watch video' mod='videos'}</span>
                                                </a>
                                                {/if}
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                {assign var=index value=$index+1}
                            {/foreach}
                            </ul>
                            <div class="clear"></div>
                        </div>
                    {/if}
                </div>
	{/if}
{/if}