<?php
/**
 * This file is part of a NewQuest Project
 *
 * (c) NewQuest <contact@newquest.fr>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author    NewQuest
 * @copyright NewQuest
 * @license   NewQuest
 */

class OzonUuidIndex
{
    public static $table = 'ozon_uuid_index';

    public static $index_cache = array();

    /**
     * @param $id_cart
     * @param bool $refresh
     * @return mixed
     */
    public static function getIndex($id_cart, $refresh = true)
    {
        if (!isset(self::$index_cache[$id_cart]) || $refresh) {
            $query = 'SELECT uuid FROM '._DB_PREFIX_.self::$table.' WHERE id_cart = '.(int)$id_cart;
            self::$index_cache[$id_cart] = Db::getInstance()->getValue($query);
        }

        return self::$index_cache[$id_cart];
    }

    /**
     * Clean all cache or just specified id_order.
     * @param null $id_cart
     */
    public static function unsetCache($id_cart = null)
    {
        if ($id_cart !== null) {
            unset(self::$index_cache[$id_cart]);
        } else {
            self::$index_cache = array();
        }
    }

    /**
     * Save configuration for specified id_order.
     * @param $id_cart
     * @param $uuid
     * @return bool
     */
    public static function saveIndex($id_cart, $uuid)
    {
        $query = 'REPLACE INTO '._DB_PREFIX_.self::$table.
            ' (`id_cart`, `uuid`)	VALUES ('.(int)$id_cart.', "'.pSQL($uuid).'")';
        if (!Db::getInstance()->Execute($query)) {
            return false;
        }

        self::unsetCache($id_cart);
        return true;
    }
}
