<?php
/**
 * This file is part of a NewQuest Project
 *
 * (c) NewQuest <contact@newquest.fr>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author    NewQuest
 * @copyright NewQuest
 * @license   NewQuest
 */

class AdminNqLogController extends ModuleAdminController
{
    /**
     * AdminNqLogController constructor.
     */
    public function __construct()
    {
        $this->bootstrap = true;
        $this->table = 'ozon_log';
        //$this->className = '';
        $this->lang = false;
        $this->deleted = false;
        $this->explicitSelect = true;

        $this->_defaultOrderBy = 'date_add';
        $this->_defaultOrderWay = 'DESC';

        $this->context = Context::getContext();

        $this->fields_list = array(
            'id_log' => array(
                'title' => $this->l('ID'),
                'align' => 'center',
                'class' => 'fixed-width-xs'
            ),
            'type' => array(
                'title' => $this->l('Type'),
                'align' => 'center',
                'class' => 'fixed-width-sm',
                'callback' => 'getTypeName'
            ),
            'message' => array(
                'title' => $this->l('Message')
            ),
            'id_entity' => array(
                'title' => $this->l('ID order'),
                'align' => 'center',
                'class' => 'fixed-width-xs'
            ),
            'date_add' => array(
                'title' => $this->l('Date'),
                'align' => 'center',
                'class' => 'fixed-width-lg',
                'type' => 'datetime',
                'filter_key' => 'a!date_add'
            ),
        );

        parent::__construct();

        $this->bulk_actions = array();
        $this->actions_available = array();
    }

    /**
     * @param $value
     * @return string
     */
    public static function getTypeName($value)
    {
        switch ($value) {
            case NQLogger::TYPE_ERROR:
                $name = '<span style="font-weight:bold; color: #FF0000;" >Error</span>';
                break;
            case NQLogger::TYPE_INFO:
                $name = '<span style="font-weight:bold; color: #009cd7;" >Info</span>';
                break;
            case NQLogger::TYPE_NOTICE:
                $name = '<span style="font-weight:bold; color: darkorange;" >Notice</span>';
                break;
            default:
                $name = '-';
                break;
        }

        return $name;
    }

    /**
     *
     */
    public function initToolbar()
    {
    }
}
